<?php
    include_once("CUserSession.php");
    include_once("CUtil.php");

    if(!isLoggedIn()){
        header('Location: http://www.thisisud.com/solutions.php');
        die();
    }
?> <!DOCTYPE html><html lang="en"><head><title>Solutions - isUD™</title><meta charset="utf-8"><meta name="viewport" content="width=device-width,initial-scale=1"><meta http-equiv="x-ua-compatible" content="ie=edge"><meta name="description" content="innovative solutions for Universal Design(isUD™) offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta name="keywords" content="inclusive design, universal design, accessibility, ada, barrier free design, wayfinding, anthropometry, design for all, diversity, wheelchair"><meta name="copyright" content="innovative solutions for Universal Design is a product of the University at Buffalo, Center for Inclusive Design and Environmental Access. All rights reserved."><meta name="dcterms.rightsHolder" content="The University at Buffalo, Center for Inclusive Design and Environmental Access."><meta property="og:title" content="Solutions - isUD™"><meta property="og:description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta property="og:image" content="/images/isUD_PR_PublicTransit_Facebook.e6c1a408.png"><meta property="og:site_name" content="thisisUD"><meta property="og:image:width" content="470"><meta property="og:image:height" content="246"><link rel="Shortcut Icon" href="favicon.ico"><link rel="stylesheet" href="CSS/jquery.mobile.custom.structure.min.1e0cf97e.css"><link rel="stylesheet" href="CSS/jquery.mobile.custom.theme.min.be05784b.css"><link rel="stylesheet" href="CSS/bootstrap.min.7cc40c19.css"><link rel="stylesheet" href="CSS/print.5e94694b.css"><link rel="stylesheet" href="CSS/custom.79b6d971.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css"><link rel="stylesheet" href="CSS/awesome-bootstrap-checkbox.d9d70e8e.css"></head><body>
    <div class="cl-global-container">
        <table class="cl-body-table">
        <thead style="margin:20px">
            <tr><th style="height:50px;text-align:center"></th></tr>
        </thead>

        <tbody>
             <tr><td>
            <div style="position:relative;" class="score_card_cover">
            <img id="id-cover" src="images/isUDScorecardCover.jpg" alt="" />
                <div style="left: 10%; position: absolute; top: 100px; font-size: xx-large; font-weight: 550;" id="id-project-name"></div>
                <div style="left: 10%; position: absolute; top: 180px; font-size: x-large; font-weight: 550;" id="id-subtitle"></div>
                <div style="position: absolute; top: 45%; left: 68%; font-size: xx-large; font-weight: 400;" id="id-progress"></div>
                <hr id="id-chapter-separator">
                <div class="qr-code">
                    <img style="position: absolute; bottom: 15%; right: 130px; width: 100px;" src="images/ISUD-QR-CODE.png"/>
                </div>
            </div>
            </td>
            <hr id="id-chapter-separator">
            </tr>
            <tr><td>
             <div class="cl-div-nav-project-award-details-holder pull-right" style="display: flex;max-width: 100%;min-width: 14.5%;height: 80px;flex-wrap: nowrap;">
                <div class="cl-div-project-award-credit-details">
                    <div class="cl-div-project-award-credit-title-holder">
                        <span class="cl-span-project-award-credit-title">Credits</span>
                    </div>
                    <div class="cl-div-project-award-credit-value-holder">
                        <div class="cl-div-project-award-credit-item-holder" id="id-div-project-award-credit-earned">
                            <span class="cl-span-project-award-credit-item-title">Earned</span>
                            <span class="cl-span-project-award-credit-item-value">0</span>
                        </div>
                        <div class="cl-div-project-award-credit-item-holder" id="id-div-project-award-credit-available">
                            <span class="cl-span-project-award-credit-item-title">Available</span>
                            <span class="cl-span-project-award-credit-item-value">100</span>
                        </div>

                        <div class="cl-div-project-award-credit-item-holder" id="id-div-project-award-credit-bonus">
                            <span class="cl-span-project-award-credit-item-title">Bonus</span>
                            <span class="cl-span-project-award-credit-item-value">0</span>
                        </div>
                    </div>
                </div>
                <div class="cl-div-project-award">
                    <div class="cl-div-project-award-title-holder">
                        <span class="cl-span-project-award-credit-title"> Score</span>
                    </div>
                    <div class="cl-div-project-award-progress-container" id="id-div-project-award-progress-container" style="margin: 0 auto;width:60%;">
                        <!-- <svg viewBox="0 0 100 100" style="display: block; width: 100%;"><path d="M 50,50 m 0,-45 a 45,45 0 1 1 0,90 a 45,45 0 1 1 0,-90" stroke="#e6e7e8" stroke-width="10" fill-opacity="0"></path><path d="M 50,50 m 0,-45 a 45,45 0 1 1 0,90 a 45,45 0 1 1 0,-90" stroke="#F7941E" stroke-width="10" fill-opacity="0" style="stroke-dasharray: 282.783, 282.783; stroke-dashoffset: 282.783;"></path></svg>
                        <div class="progressbar-text" style="position: absolute; left: 50%; top: 50%; padding: 0px; margin: 0px; transform: translate(-50%, -50%); color: black; font-size: 1.2em; font-weight: 600;">0</div> -->
                    </div>
                </div>
            </div>
        </td></tr>

        <tr><td>
        <div class="cl-printable-doc">
            <div class="cl-chapter-holder" >
                <div class="cl-project-score-holder"> 


                </div>
                <div class="row cl-chapter-info-block">
                    <div class="col-2" style="display:inline-flex;">
                        <div class="cl-chapter-number" style="margin-left:60px"></div>
                        <div><img class="cl-chapter-title-img" src="images/chapterarrow.0987a391.png"/></div>
                    </div>
                    <div class="col-10">
                        <div class="cl-chapter-title"></div>
                        <div class="cl-chapter-credits"></div>
                    </div>
                </div>

                <div class="cl-header-holder">
                    <div class="row cl-header-info">
                        <div class="cl-header-number col-2"></div>
                        <div class="col-10">    
                            <div class="cl-header"></div>
                            <hr class="cl-header-hr" style="display:none;"/>
                            <div class="cl-instruction"></div>
                        </div>
                    </div>
                        <!-- only visible for level 3 header -->
                        <div class="cl-sub-header-holder">
                            <div class="row">
                                <div class="cl-sub-header-number col-2"></div>
                                <div class="col-10">
                                    <div class="cl-sub-header"></div>
                                    <hr style="display:none"/>
                                    <div class="cl-sub-instruction"></div>
                                </div>
                            </div>

                            <div class="cl-sub-solutions-holder">
                                <div class="cl-sub-solution-holder row">
                                    <div class="cl-sub-solution-number col-2"><div class="cl-sub-solution-number-text"></div><div class="cl-sub-solution-required" style="display:none">Required</div></div>
                                    <div class="cl-sub-solution col-9"></div>
                                    <div class="cl-sub-solution-check-box col-1" style="display:none"><input type="checkbox" disabled/> </div>
                                </div>
                            </div>
                        </div>
                    
                    <div class="cl-solutions-holder">
                        <div class="cl-solution-holder row">
                            <div class="cl-solution-number col-2"><div class="cl-solution-number-text"></div><div class="cl-solution-required" style="display:none">Required</div></div>
                            <div class="cl-solution col-9"></div>
                            <div class="cl-solution-check-box col-1" style="display:none;"><input type="checkbox" disabled/> </div>
                        </div>
                    </div>
                </div>
            </div>
            <hr id="id-chapter-separator">
        </div>
        </td></tr></tbody>
        <tfoot style="margin:20px">
            <tr><th style="height:50px;text-align:center"></th></tr>
        </tfoot>
        </table>
    </div><script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.1.1/js/tether.min.js"></script><script src="JS/bootstrap.min.61f338f8.js"></script><script src="JS/jquery.mobile.custom.min.8fe6f447.js"></script><script src="JS/lib-unveil.min.c14400f8.js"></script><script src="JS/print_solutions.min.0873f7ad.js"></script><script src="JS/progressbar.min.c5d0fe77.js"></script></body></html>