<?php
    include_once("CUserSession.php");
    include_once("CUtil.php");
    if(!isLoggedIn()){
        header("Location: register.php");
        die();
    }
?> <!DOCTYPE html><html lang="en"><head><title>MemberShip - isUD™</title><meta charset="utf-8"><meta name="viewport" content="width=device-width,initial-scale=1"><meta http-equiv="x-ua-compatible" content="ie=edge"><meta name="description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta name="keywords" content="inclusive design, universal design, accessibility, ada, barrier free design, wayfinding, anthropometry, design for all, diversity, wheelchair"><meta name="copyright" content="innovative solutions for Universal Design is a product of the University at Buffalo, Center for Inclusive Design and Environmental Access. All rights reserved."><meta name="dcterms.rightsHolder" content="The University at Buffalo, Center for Inclusive Design and Environmental Access."><meta property="og:title" content="Profile Membership - isUD™"><meta property="og:description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta property="og:image" content="/images/isUD_PR_PublicTransit_Facebook.e6c1a408.png"><meta property="og:site_name" content="thisisUD"><meta property="og:image:width" content="470"><meta property="og:image:height" content="246"><link rel="Shortcut Icon" href="favicon.ico"><link rel="stylesheet" href="CSS/bootstrap.min.7cc40c19.css"><link rel="stylesheet" href="CSS/bootstrap-select.min.92f660cd.css"><link rel="stylesheet" href="CSS/dataTables.bootstrap4.12f1d4f3.css"><link rel="stylesheet" href="CSS/custom.79b6d971.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css"><style>table {
            font-family: arial, sans-serif;
            border-collapse: collapse;
            width: 100%;
        }

        td, th {
            border: 0px solid #dddddd;
            text-align: center;
            padding: 15px;
            font-size: 12px;
            font-weight: bold;
        }

        tr:nth-child(odd) {
            background-color: #f9f9f9;
        }

        .roundedBoxedClass {
            display:flex;
            width: 100%;
            height:10%;
            padding-left: 12px;
            border-top-left-radius: 15px;
            border-top-right-radius: 15px;
            position:relative;
            background:#F7941E;
            padding-top:15px;
        }

        .roundedBoxedClassTest {
            display:flex;
            flex-direction:column;
            border-radius: 15px;
            -webkit-border-radius: 15px;
            -moz-border-radius: 15px; 
            margin-left:15px;
            width:50%;
            margin-top:17px;
        }</style></head><body><div class="cl-container cl-wrapper" id="id-wrapper"> <?php
            if(!isLoggedIn()){
                Util::ScopedIncludeOnce("Banner.php", array('includerFile' => __FILE__));
            }else{
                Util::ScopedIncludeOnce("Banner_Login.php", array('includerFile' => __FILE__));
            }
        ?> <section id="id-global-container"><div class="cl-div-width-container ongoing-projects"><section><div id="content-holder"><div id="dashboard"><div class="big-screen-hidden cl-div-solutions-holder"><p>Thank you for your interest in innovative solutions for Universal Design (isUD™). Due to the large amount of content, the solutions are not available on small screens or small browser windows. To see the complete list of solutions, please make your browser window full screen, or access the site on device with a larger screen. If you have any questions, please contact us at <a href="mailto:info@thisisud.com" target="_blank">info@thisisud.com</a>.</p></div><div class="small-screen-hidden cl-div-project-dashboard-holder"><div id="id-title-bar"><div class="cl-div-site-breadcrumb-static" style="font-size: 14px;"><span class="" style="font-size: 14px; font-weight: bold;"><a>My Account > <a><a href="profileMemberShip.php">Membership</a> <a style="color: grey;">> Confirmation</a></a></a></span></div></div><div class="cl-info-footer" id="id-title-bar" style="display:flex; width:100%"><div class="" id="id-project-title-text" style="align-self: auto;"><span class="cl-span-site-title">Membership Confirmation</span></div></div><div class="cl-mem-benefits"><div style="width:45%;"><p id="membership-text" style="padding-left: 15px; font-weight:normal; margin-top:20px;">Thank you for taking the first step towards a membership subscription with isUD. Please review the information below and click on the "Pay Now" button to proceed.</p><table style="margin-top:10px"><tr><td style="text-align:left; font-weight:575; font-size:1rem">Membership Level</td><td style="font-weight: normal; font-size: 1rem; text-align:left; text-indent:7.5em;" id="membership-level"></td></tr><tr><td style="text-align:left; font-weight:575; font-size:1rem">How many years?</td><td style="font-weight: normal; font-size: 1rem; text-align:left; text-indent:7.5em;" id="years"></td></tr><tr><td style="text-align:left; font-weight:575; font-size:1rem">Start Date</td><td style="font-weight: normal; font-size: 1rem; text-align:left; text-indent:7.5em;" id="start-date"></td></tr><tr><td style="text-align:left; font-weight:575; font-size:1rem">End Date</td><td style="font-weight: normal; font-size: 1rem; text-align:left; text-indent:7.5em;" id="end-date"></td></tr><tr><td style="text-align:left; font-weight:575; font-size:1rem">Total Amount Due<br>(Membership purchases are non-refundable)</td><td style="font-weight: normal; font-size: 1rem; text-align:left; text-indent:7.5em;" id="amount-due"></td></tr></table><p style="padding-left:15px; margin-top:15px; height:10px" class="font-weight-bold" id="terms-and-conditions">Terms and Conditions</p><div style="padding-left:15px;"><input type="checkbox" autocomplete="off" name="terms-and-conditions" id="terms-and-conditions-check"> I accept the <a href="/terms-of-use" style="color:#002f56;">terms &amp; conditions</a><div class="modal" id="myModal"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><h4 class="modal-title">Terms & Conditions</h4><button type="button" class="close" data-dismiss="modal">&times;</button></div><div class="modal-body">Lorem ipsum dolor sit, amet consectetur adipisicing elit. Laudantium molestias consequatur quasi eius officiis sed magnam qui vel est cumque placeat vitae et aliquid repellendus fugit iste, beatae ratione? Ex? Lorem ipsum dolor sit, amet consectetur adipisicing elit.</div></div></div></div></div><div style="padding-left: 15px; margin-top:10px; font-weight:normal"><p id="terms-and-conditions">When you click Pay Now, you will be redirected to the University at Buffalo's secure payment gateway to complete the payment process.</p></div><div style="display:block; flex-direction:row; align-items:center"><input id="back" class="membershipbutton backbutton go-back" style="float:left; width: 8rem; border: none; margin-left:15px" type="submit" value="Back"> <input id="payNow" class="membershipbutton paynowbutton pay-now" style="float:left; width: 8rem; border: none; margin-left:150px; color: black;" type="submit" value="Pay Now" disabled=""></div></div><div class="roundedBoxedClassTest"><div class="roundedBoxedClass"><p style="padding-left:15px;" class="font-weight-bold" id="benefit-type">Supporter Benefits</p></div><div style="background:#f9f9f9; padding-top:30px;"><ul id="id-ul-membership-benefits"></ul></div><div style="display:flex; flex-direction:row; justify-content:center; background:#f9f9f9; padding-top:20px; padding-bottom:20px; border-bottom-left-radius: 15px; border-bottom-right-radius: 15px;"><div><img class="cl-img-contact-section" aria-hidden="true" src="" data-src="images/emailicon.0c0a4646.png" alt="email icon"></div><div style="display:flex; flex-direction:column; align-items:left; padding:15px;"><p style="margin:0;">Have a question?</p><p style="font-weight:bold; margin:0;"><a href="mailto:info@thisisud.com">Email us at info@thisisud.com</a></p></div></div></div></div><div style="display:flex; flex-direction:row; justify-content: space-between;"></div></div></div></div></section></div></section> <?php
            include_once("Footer.php");
        ?> <?php
            include_once("IdleTimeLogoutPopup.php");
        ?> </div><script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.1.1/js/tether.min.js"></script><script type="text/javascript">var userRole='<?php echo $_SESSION["user"]->authtype_id?>';</script><script src="JS/constants.min.45228e21.js"></script><script src="JS/bootstrap.min.61f338f8.js"></script><script src="JS/lib-unveil.min.c14400f8.js"></script><script src="JS/banner.min.481c978f.js"></script><script src="JS/index.min.4e09dd2c.js"></script><script src="JS/progressbar.min.c5d0fe77.js"></script><script src="JS/profileMemberShipSubscription.min.f1124b69.js"></script><script src="JS/popup.min.cbc0cd32.js"></script></body></html>