<?php
    include_once("CUserSession.php");
    include_once("CUtil.php");
    if(!isLoggedIn()){
        header("Location: register.php");
        die();
    }
?> <!DOCTYPE html><html lang="en"><head><title>MemberShip - isUD™</title><meta charset="utf-8"><meta name="viewport" content="width=device-width,initial-scale=1"><meta http-equiv="x-ua-compatible" content="ie=edge"><meta name="description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta name="keywords" content="inclusive design, universal design, accessibility, ada, barrier free design, wayfinding, anthropometry, design for all, diversity, wheelchair"><meta name="copyright" content="innovative solutions for Universal Design is a product of the University at Buffalo, Center for Inclusive Design and Environmental Access. All rights reserved."><meta name="dcterms.rightsHolder" content="The University at Buffalo, Center for Inclusive Design and Environmental Access."><meta property="og:title" content="Profile Membership - isUD™"><meta property="og:description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta property="og:image" content="/images/isUD_PR_PublicTransit_Facebook.e6c1a408.png"><meta property="og:site_name" content="thisisUD"><meta property="og:image:width" content="470"><meta property="og:image:height" content="246"><link rel="Shortcut Icon" href="favicon.ico"><link rel="stylesheet" href="CSS/bootstrap.min.7cc40c19.css"><link rel="stylesheet" href="CSS/bootstrap-select.min.92f660cd.css"><link rel="stylesheet" href="CSS/dataTables.bootstrap4.12f1d4f3.css"><link rel="stylesheet" href="CSS/custom.79b6d971.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css"><style>table {
        font-family: arial, sans-serif;
        border-collapse: collapse;
        width: 100%;
        }

        td, th {
        border: 0px solid #dddddd;
        text-align: center;
        padding: 15px;
        font-size: 14px;
        }

        tr:nth-child(1) {
        background-color: #f9f9f9;
        }

        tr:nth-child(even) {
        background-color: #f9f9f9;
        }

        select {
        -webkit-appearance: none;
        -moz-appearance: none;
        -ms-appearance: none;
        appearance: none;
        outline: 4;
        box-shadow: none;
        border: 0 !important;
        background: #ffffff;
        background-image: none;
        border: 6px solid transparent;
        border-color: #000;
        }

        select::-ms-expand {
        display: none;
        }

        .select {
        position: relative;
        display: flex;
        width: 12em;
        height: 2em;
        line-height: 2;
        background: #000000;
        overflow: hidden;
        border-radius: .45em;
        text-align-last:center;
        border: 1px solid transparent;
        margin:auto;
        }

        select {
        flex: 1;
        padding: 0 .5em;
        color: #000000;
        cursor: pointer;
        }

        .select::after {
        position: absolute;
        content: "";
        top: 11px;
        right: 10px;
        width: 0;
        height: 0;
        border: 6px solid transparent;
        border-color: #000 transparent transparent transparent;
        cursor: pointer;
        pointer-events: none;
        -webkit-transition: .25s all ease;
        -o-transition: .25s all ease;
        transition: .25s all ease;
        }</style></head><body><div class="cl-container cl-wrapper" id="id-wrapper"> <?php
            if(!isLoggedIn()){
                Util::ScopedIncludeOnce("Banner.php", array('includerFile' => __FILE__));
            }else{
                Util::ScopedIncludeOnce("Banner_Login.php", array('includerFile' => __FILE__));
            }
        ?> <section id="id-global-container"><div class="cl-div-width-container ongoing-projects"><section><div id="content-holder"><div id="dashboard"><div class="big-screen-hidden cl-div-solutions-holder"><p>Thank you for your interest in innovative solutions for Universal Design (isUD™). Due to the large amount of content, the solutions are not available on small screens or small browser windows. To see the complete list of solutions, please make your browser window full screen, or access the site on device with a larger screen. If you have any questions, please contact us at <a href="mailto:info@thisisud.com" target="_blank">info@thisisud.com</a>.</p></div><div class="small-screen-hidden cl-div-project-dashboard-holder"><div class="cl-info-footer" id="id-title-bar" style="display:flex; margin-top:15px; width:100%"><div class="" id="id-project-title-text" style="align-self: auto;"><span class="cl-span-site-title">Membership</span></div></div><p id="opening-note" style="margin-left:15px; font-size:14px; margin-top:20px">Thank you for using isUD. You are currently subscribed as a Supporter. You can upgrade to Innovator membership at any time for additional benefits. If you have any questions, please contact us at <a href="mailto:ap-idea@buffalo.edu">ap-idea@buffalo.edu</a>.</p><table style="margin-right:20px"><tr style="border-bottom: 1px solid black"><th class="pull-left">Benefits</th><th id="supporter-title">Supporter</th><th id="innovator-title">Innovator</th></tr><tr><td id="table-row1-col-1" style="text-align:left">Access all solutions</td><td id="table-row1-col-2"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td id="table-row1-col-3"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td id="table-row2-col-1" style="text-align:left">Access all drawings and figures</td><td id="table-row2-col-2"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td id="table-row2-col-3"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td id="table-row3-col-1" style="text-align:left">Access all design resources</td><td id="table-row3-col-2"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td id="table-row3-col-3"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td id="table-row4-col-1" style="text-align:left">Access a printable scorecard for all projects</td><td id="table-row4-col-2"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td id="table-row4-col-3"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td id="table-row5-col-1" style="text-align:left">Submit projects for pre-certification, and isUD Certification with on-site audit</td><td id="table-row5-col-2"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td id="table-row5-col-3"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td id="table-row6-col-1" style="text-align:left">Number of projects</td><td id="table-row6-col-2" style="font-weight:bold; text-align:center;">1 project/year</td><td id="table-row6-col-3" style="font-weight:bold; text-align:center;">2 projects/year</td></tr><tr><td id="table-row7-col-1" style="text-align:left">User Accounts</td><td id="table-row7-col-2">1</td><td id="table-row7-col-3">3</td></tr><tr><td id="table-row8-col-1" style="text-align:left">Get a 20% discount on recertification if subscription is active for all 5 years</td><td id="table-row8-col-2"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td id="table-row8-col-3"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr style="border-bottom: 1px solid black;"><td id="table-row10-col-1" style="text-align:left">Access to free and discounted online course</td><td id="table-row10-col-2"></td><td id="table-row10-col-3"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr style="background-color: #ffffff; line-height:5%;"><td id="table-row11-col-1" style="text-align:left;"><div><p style="font-weight:bold; float:left;">Cost &nbsp;</p><p style="float:left">(Membership purchases are non-refundable)</p></div></td><td id="table-row11-col-2" style="font-weight:bold">$500/year</td><td id="table-row11-col-3" style="font-weight:bold">$1000/year</td></tr><tr style="background-color: #ffffff; line-height:0%;"><td id="table-row17-col-1"></td><td id="table-row17-col-2" style="color:red;"></td><td id="table-row17-col-3" style="color:red;"></td></tr><tr style="background-color: #ffffff; line-height:0%;"><td id="table-row18-col-1"></td><td id="table-row18-col-2" style="color:red;"></td><td id="table-row18-col-3" style="color:red;"></td></tr><tr style="line-height:0%;"><td id="table-row12-col-1"></td><td id="table-row12-col-2" style="font-weight:bold;">Number of Years</td><td id="table-row12-col-3" style="font-weight:bold;">Number of Years</td></tr><tr style="line-height:0%; background-color:#ffffff;"><td id="table-row13-col-1"></td><td id="table-row13-col-2"><div class="select" id="choose_supp_selector"><select name="slct" id="slct-for-supporter"><option class="font-weight-bold" id="year1" value="1">1 Year</option><option class="font-weight-bold" id="year2" value="2">2 Years</option><option class="font-weight-bold" id="year3" value="3">3 Years</option><option class="font-weight-bold" id="year4" value="4">4 Years</option><option class="font-weight-bold" id="year5" value="5">5 Years</option></select></div></td><td id="table-row13-col-3"><div class="select" id="choose_invv_selector"><select name="slct" id="slct-for-innovator"><option class="font-weight-bold" id="innv_year1" value="1">1 Year</option><option class="font-weight-bold" id="innv_year2" value="2">2 Years</option><option class="font-weight-bold" id="innv_year3" value="3">3 Years</option><option class="font-weight-bold" id="innv_year4" value="4">4 Years</option><option class="font-weight-bold" id="innv_year5" value="5">5 Years</option></select></div></td></tr><tr style="line-height:0%;"><td id="table-row14-col-1"></td><td id="table-row14-col-2" style="font-weight:bold;">Total</td><td id="table-row14-col-3" style="font-weight:bold;">Total</td></tr><tr style="line-height:0%; background-color:#ffffff"><td id="table-row15-col-1"></td><td id="cost-in-dollars-supporter" style="font-weight:bold;">$500</td><td id="cost-in-dollars-innovator" style="font-weight:bold;">$1000</td></tr><tr style="background-color:white;"><td id="table-row16-col-1"></td><td id="table-row16-col-2"><input id="supp-button" class="membershipbutton" type="submit" name="submit" value="Renew"></td><td id="table-row16-col-3"><input id="innv-button" class="membershipbutton" type="submit" name="submit" value="Upgrade"></td></tr></table></div></div></div></section></div></section><div class="modal fade cl-ud-modal" id="id-upgrade-membership-popup-renew" tabindex="-1" role="dialog" aria-labelledby="upgrade-popup-1" aria-hidden="true"><div class="modal-dialog modal-dialog-centered" id="upgrade-popup-1" role="document"><div class="modal-content popup-container" style="text-align:left; left: -15%; height:320px ; background-color: #f9f9f9;"><div class="modal-header" style="border-bottom: none; width:600px; background-color: #f9f9f9;"><div class="cl-project-submit-option-container" style="background-color: #f9f9f9;"><p><b>Upgrade to Innovator Options</b></p><div id="current_sub_end_date">Your current subscription will end</div><div style="padding-left:20px"><div id="upgrade_base_price_today_renew">Upgrade starting TODAY:$500</div><div>Select the number of years you would like to add:</div><div class="select" style="margin-left:20px"><select name="years" id="upgradePlan"></select></div><div>The selected subscription will end on 12/16/2021.</div></div><br><div><input id="continue-button-renew" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Continue" disabled="disabled"> <input id="cancel-button-renew" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Cancel"></div></div></div></div></div></div><div class="modal fade cl-ud-modal" id="id-renew-continue-popup" tabindex="-1" role="dialog" aria-labelledby="continue-popup" aria-hidden="true"><div class="modal-dialog modal-dialog-centered" id="continue-popup" role="document"><div class="modal-content popup-container" style="text-align:left; height:320px; left: -15%; background-color: #f9f9f9;"><div class="modal-header" style="border-bottom: none; width:600px; background-color: #f9f9f9;"><div class="cl-project-submit-option-container" style="background-color: #f9f9f9;"><p style="font-size: 1.5rem"><b>Renew</b></p><p>The Innovator level allows 2 projects per year, and 3 users per project, plus additional discounts.</p><p>Do you want to UPGRADE to INNOVATOR or RENEW at the SUPPORTER level?</p><input type="radio" id="Option1" name="upgrade" value="upgrade_innv"> <label for="Option1" style="margin-left:5px">Upgrade to Innovator</label><br><input type="radio" id="Option2" name="upgrade" value="renew_supp"> <label for="Option2" style="margin-left:5px">Renew Supporter</label><br><div><input id="continue-button-1" style="float:right; width: 8rem;  margin-right:10px" class="membershipbutton" value="Continue"> <input id="cancel-button-1" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Cancel"></div></div></div></div></div></div><div class="modal fade cl-ud-modal" id="id-renew-continue-next-steps-popup" tabindex="-1" role="dialog" aria-labelledby="renew-popup" aria-hidden="true"><div class="modal-dialog modal-dialog-centered" id="renew-popup" role="document"><div class="modal-content popup-container" style="text-align:left; left: -15%; background-color: #f9f9f9;"><div class="modal-header" style="border-bottom: none; width:600px; background-color: #f9f9f9;"><div class="cl-project-submit-option-container" style="background-color: #f9f9f9;"><p id="renew_heading" style="font-size: 1.5rem"> <b> Renew Options </b> </p><p id="current_sub_end_date_renew"> Your current subscription will end 12/31/2021 </p><p id="renew_no_mem_extension_msg" style="display:none; text-align: center; margin-top:50px; margin:auto;"> Thank you for using isUD. You are not able to extend your membership beyond your current expiration date at this time. </p><p id="renew_sub_heading"></p><div><div class="select" style="margin-left:10px"><select name="years" id="renewPlan"></select></div><p id="subs_end_date_with_years_renew" style="padding-left:10px; padding-top:10px">The selected subscription will end on 12/16/2021.</p></div><div><input id="continue-button-2" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Continue"> <input id="cancel-button-2" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Cancel"></div></div></div></div></div></div><div class="modal fade cl-ud-modal" id="id-upgrade-membership-popup" tabindex="-1" role="dialog" aria-labelledby="upgrade-popup" aria-hidden="true"><div class="modal-dialog modal-dialog-centered" id="upgrade-popup" role="document"><div class="modal-content popup-container" style="text-align:left; left: -15%; height:370px; background-color: #f9f9f9;"><div class="modal-header" style="border-bottom: none; width:600px; background-color: #f9f9f9;"><div class="cl-project-submit-option-container" style="background-color: #f9f9f9;"><p><b>Upgrade to Innovator Options</b></p><p id="current_sub_end_date_upgrade">Your current subscription will end</p><input type="radio" style="vertical-align: 20px" id="Option1" name="upgrade" value="today"> <label for="Option1"><div id="upgrade_base_price_today" style="padding-left:5px">Upgrade starting TODAY:$500</div><div id="subs_end_date" style="font-size:0.75rem; margin-left:5px; display:inline">Subscription will end on 12/16/2021.</div><div class="click-to-top" style="float:right; padding-left: 10px;"><img alt="Help Icon" src="images/help_icon.582f7f5c.png" style="width:1.4em"> <span class="tooltiptext">Since you recently subscribed to the Supporter level for $500, rather than pay the full $1,000 price for the Innovator level, we are allowing you to pay only the difference in price ($500). However, since you already used part of your Supporter subscription, the additional $500 does not cover the entire remainder of the year at the new Innovator rate. So, we will prorate the number of days used at the Supporter rate, and subtract the equivalent prorated number of days at the new Innovator rate from the end of your subscription. Please <a href="mailto:info@thisisud.com" target="_blank">contact us</a> if you have any further questions.</span></div></label><br><input type="radio" style="vertical-align: 100px" id="Option2" name="upgrade" value="todayWithYears"> <label style="padding-left:5px" for="Option2"><div id="upgrade_additional_price_today">Upgrade starting TODAY: $1000 per added year</div><div><div style="padding-left:20px">Select the number of years you would like to add:</div><div class="select" style="margin-left:20px"><select name="years" id="upgradePlanYears"></select></div><div id="subs_end_date_with_years" style="padding-left:20px">The selected subscription will end on 12/16/2021.</div></div><br></label><br><div><input id="continue-button" style="float:right; width: 8rem; border: none;" class="membershipbutton" value="Continue" disabled="disabled"> <input id="cancel-button" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Cancel"></div></div></div></div></div></div><div class="modal fade cl-ud-modal" id="id-upgrade-membership-popup-less_than_90" tabindex="-1" role="dialog" aria-labelledby="upgrade-popup-2" aria-hidden="true"><div class="modal-dialog modal-dialog-centered" id="upgrade-popup-2" role="document"><div class="modal-content popup-container" style="text-align:left; left: -15%; height:350px ; background-color: #f9f9f9;"><div class="modal-header" style="border-bottom: none; width:600px; background-color: #f9f9f9;"><div class="cl-project-submit-option-container" style="background-color: #f9f9f9;"><p><b>Upgrade to Innovator Options</b></p><p id="current_sub_end_date_less_than_90">Your current subscription will end</p><input type="radio" style="vertical-align: 20px" id="o1" name="upgrade" value="today"> <label for="o1"><div id="upgrade_base_price_today_less_than_90" style="padding-left:5px">Upgrade starting TODAY:$1000</div><div id="subs_end_date_less_than_90" style="font-size:0.75rem; padding-left:5px; display:inline">Subscription will end on 12/16/2021.</div><div class="click-to-top" style="float:right; font-size:0.75rem; margin-left:5px"><img alt="Help Icon" src="images/help_icon.582f7f5c.png" style="width:1.4em"> <span class="tooltiptext">Since you recently subscribed to the Supporter level for $500, rather than pay the full $1,000 price for the Innovator level, we are allowing you to pay only the difference in price ($500). However, since you already used part of your Supporter subscription, the additional $500 does not cover the entire remainder of the year at the new Innovator rate. So, we will prorate the number of days used at the Supporter rate, and subtract the equivalent prorated number of days at the new Innovator rate from the end of your subscription. Please <a href="mailto:info@thisisud.com" target="_blank">contact us</a> if you have any further questions.</span></div></label><br><input type="radio" id="o2" name="upgrade" value="todayWithYears"> <label for="o2" style="padding-left:5px">Upgrade when my current subscription ends: $1,000<br></label><br><div id="select-dropdown"><div style="padding-left:20px">Select the number of years</div><div class="select" style="margin-left:20px"><select name="years" id="upgrade-plan-less-than-90"></select></div><div id="subs_end_date_with_years_less_than_90" style="padding-left:20px">The selected subscription will end on 12/16/2021.</div></div><br><div><input id="continue-button-less-than-90" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Continue"> <input id="cancel-button-less-than-90" style="float:right; width: 8rem; margin-right:10px" class="membershipbutton" value="Cancel"></div></div></div></div></div></div><div class="modal fade cl-ud-modal" id="id-downgrade-popup" tabindex="-1" role="dialog" aria-labelledby="downgrade-popup" aria-hidden="true"><div class="modal-dialog modal-dialog-centered" id="downgrade-popup" role="document"><div class="modal-content popup-container" style="text-align:left; left: -15%; background-color: #f9f9f9;"><div class="modal-header" style="border-bottom: none; width:600px; background-color: #f9f9f9;"><div class="cl-project-submit-option-container" style="background-color: #f9f9f9;"><p style="font-size: 1.5rem"><b>Downgrade Options</b></p><p>You have selected that you wish to downgrade to the SUPPORTER level. You will be limited to 1 project per year and 1 user per project. See all of the benefits you will be missing out on by downgrading.</p><p>Are you sure you want to downgrade?</p><input type="radio" id="downgrade-yes" name="downgrade" value="Yes"> <label for="downgrade-yes" style="padding-left:5px">Yes</label><br><input type="radio" id="downgrade-no" name="downgrade" value="No"> <label for="downgrade-no" style="padding-left:5px">No</label><br><div><input id="continue-downgrade-button-1" style="width: 8rem; margin-right:10px" class="membershipbutton" value="Continue"></div></div></div></div></div></div><div class="modal fade cl-ud-modal" id="id-downgrade-yes-popup" tabindex="-1" role="dialog" aria-labelledby="downgrade-yes-popup" aria-hidden="true"><div class="modal-dialog modal-dialog-centered" id="downgrade-yes-popup" role="document"><div class="modal-content popup-container" style="text-align:left; height:370px; background-color: #f9f9f9;"><div class="modal-header" style="border-bottom: none; width:600px; background-color: #f9f9f9;"><div class="cl-project-submit-option-container" style="background-color: #f9f9f9;"><p style="font-size: 1.5rem"><b>Downgrade Options</b></p><p id="id-downgrade-yes-sub-end">Your current subscription will end on</p><p id="id-downgrade-yes-extend-sub-end">isUD does not offer refunds, as per our terms of use. Downgrading your membership level will extend the end date of your new SUPPORTER subscription to.</p><p>Are you still sure you want to downgrade?</p><input type="radio" id="yes-option" name="downgrade" value="Yes"> <label for="yes-option" style="padding-left:5px">Yes</label><br><input type="radio" id="no-option" name="downgrade" value="No"> <label for="no-option" style="padding-left:5px">No</label><div><input id="continue-downgrade-button-2" style="width: 8rem; margin-right:10px;" class="membershipbutton" value="Continue"></div></div></div></div></div></div> <?php
            include_once("Footer.php");
        ?>  <?php
            include_once("popUpSupp.php");
        ?> <?php
            include_once("popUp.php");
        ?> <?php
            include_once("popUpPricePlan.php");
        ?>  <?php
            include_once("IdleTimeLogoutPopup.php");
        ?> </div><script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.1.1/js/tether.min.js"></script><script type="text/javascript">var userRole='<?php echo $_SESSION["user"]->authtype_id?>';</script><script src="JS/constants.min.45228e21.js"></script><script src="JS/bootstrap.min.61f338f8.js"></script><script src="JS/lib-unveil.min.c14400f8.js"></script><script src="JS/banner.min.481c978f.js"></script><script src="JS/index.min.4e09dd2c.js"></script><script src="JS/progressbar.min.c5d0fe77.js"></script><script src="JS/profileMemberShipAfterReg.min.874615a3.js"></script><script src="JS/popup.min.cbc0cd32.js"></script></body></html>