<?php
    include_once("CUserSession.php");
    include_once("CUtil.php");
?> <!DOCTYPE html><html lang="en"><head><title>innovative solutions for Universal Design(isUD™)</title><meta charset="utf-8"><meta name="viewport" content="width=device-width,initial-scale=1"><meta http-equiv="Refresh" content="0; url=register.php"><meta http-equiv="x-ua-compatible" content="ie=edge"><meta name="description" content="innovative solutions for Universal Design(isUD™) offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta name="keywords" content="inclusive design, universal design, accessibility, ada, barrier free design, wayfinding, anthropometry, design for all, diversity, wheelchair"><meta name="copyright" content="innovative solutions for Universal Design is a product of the University at Buffalo, Center for Inclusive Design and Environmental Access. All rights reserved."><meta name="dcterms.rightsHolder" content="The University at Buffalo, Center for Inclusive Design and Environmental Access."><meta property="og:title" content="innovative solutions for Universal Design(isUD™)"><meta property="og:description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta property="og:image" content="/images/isUD_PR_PublicTransit_Facebook.e6c1a408.png"><meta property="og:site_name" content="thisisUD"><meta property="og:image:width" content="470"><meta property="og:image:height" content="246"><link rel="Shortcut Icon" href="favicon.ico"><link rel="stylesheet" href="CSS/bootstrap.min.7cc40c19.css"><link rel="stylesheet" href="CSS/bootstrap-select.min.92f660cd.css"><link rel="stylesheet" href="CSS/custom.5382de13.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css"></head><body><div class="cl-container cl-wrapper" id="id-wrapper"> <?php
            if(!isLoggedIn()){
                Util::ScopedIncludeOnce("Banner.php", array('includerFile' => __FILE__));
            }else{
                Util::ScopedIncludeOnce("Banner_Login.php", array('includerFile' => __FILE__));
            }
        ?> <section id="id-global-container"><div class="cl-div-width-container"><section><div><table class="cl-tbl-navs"><tr><td><div id="content-holder"><div class="tab-content"><div class="tab-pane fade show active" id="home" role="tabpanel"><div><div id="carousel-holder"><div id="carousel-example-generic" class="small-screen-hidden no-border-left carousel slide" data-interval="false" data-ride="carousel"><ol class="carousel-indicators"><li data-target="#carousel-example-generic" data-slide-to="0" class="active"></li><li data-target="#carousel-example-generic" data-slide-to="1"></li><li data-target="#carousel-example-generic" data-slide-to="2"></li></ol><div class="carousel-inner" role="listbox"><div class="carousel-item active"><img alt="Exterior of Greiner Hall, University at Buffalo (innovative solutions for universal design, Click to Learn More)" class="cl-carousel-image" data-src="images/slider1.2a816424.jpg" src="images/slider1.2a816424.jpg"></div><div class="carousel-item"><img alt="Exterior of Greiner Hall, University at Buffalo (Make the environment more inclusive for all, Click to Learn More)" class="cl-carousel-image" data-src="images/slider2.8365bf81.jpg" src="images/slider2.8365bf81.jpg"></div><div class="carousel-item"><img alt="Exterior of Greiner Hall, University at Buffalo (Translate Knowledge into solutions for practice, Click to Learn More)" class="cl-carousel-image" data-src="images/slider3.2e9f6bb7.jpg" src="images/slider3.2e9f6bb7.jpg"></div></div><a class="left carousel-control" href="#carousel-example-generic" role="button" data-slide="prev"><span class="icon-prev" aria-hidden="true"></span> <span class="sr-only">Previous</span> </a><a class="right carousel-control" href="#carousel-example-generic" role="button" data-slide="next"><span class="icon-next" aria-hidden="true"></span> <span class="sr-only">Next</span></a></div></div><div class="hide col-md-3 thick-border no-border-right" id="id-div-twitter-container"></div></div><div class="big-screen-hidden" id="id-div-middle-image-holder"><a href="instructions.php"><img id="id-img-middle-image" src="images/MiddleImage.c704a6f2.png" data-src="images/MiddleImage.c704a6f2.png" alt="Making the environment more inclusive for all"></a></div><div><div class="cl-cards-bottom no-border-left col-md-12"><div><div class="card-deck col-md-12"><div class="card" style="background: #0275d8"><a href="solutions.php#credits"><img class="card-img-top" data-src="images/index_card2.5d501eb4.jpg" src="images/index_card2.5d501eb4.jpg" alt="Group of individuals having a conversation around a table"><div class="card-block" id="index-card1"><h5 class="card-title" style="margin-top:6%"><b>Design. Build. Empower.</b></h5></div></a></div><div class="card" style="background: #f7941e"><a href="testimonials.php"><img class="card-img-top" data-src="images/index_card1.7063a707.jpg" src="images/index_card1.7063a707.jpg" alt="Exterior perspective an office building"><div class="card-block" id="index-card2"><h5 class="card-title"><b>See what people are<br>saying about isUD</b></h5></div></a></div> <?php if(!isLoggedIn()){
                                                                    echo ('
                                                                <div class="card small-screen-hidden" id="id-div-card-quick-login">
                                                                    <div class="card-block">
                                                                        <h5 class="card-title">Login</h5>
                                                                        <form id="id-form-login" method="post">
                                                                            <div id="id-div-form">
                                                                                <fieldset class="form-group">
                                                                                <legend class="sr-only">E-mail Address</legend>
                                                                                    <label class="sr-only" for="id-login-short-inp-email">E-mail Address</label>
                                                                                    <input type="email" class="form-control" id="id-login-short-inp-email" name="id-login-short-inp-email" placeholder="E-mail Address">
                                                                                </fieldset>
                                                                                <fieldset class="form-group">
                                                                                <legend class="sr-only">Login Password</legend>
                                                                                    <label class="sr-only" for="id-login-short-inp-password">Password</label>
                                                                                    <input type="password" class="form-control" id="id-login-short-inp-password" name="id-login-short-inp-password" placeholder="Password">
                                                                                </fieldset>
                                                                                <div>
                                                                                    <span class="cl-error-lbl" id="id-login-short-inp-msg"></span>
                                                                                </div>

                                                                            </div>
                                                                            <div id="id-login-btn">
                                                                                <center>
                                                                                    <input class="btn btn-primary" id="id-btn-login-short-submit" style="margin: 5%;" type="submit" value="Login"/>
                                                                                </center>
                                                                                <div class="cl-div-card-links-holder">
                                                                                    <a href="forgotPassword.php" id="id-a-forgot-pass" class="cl-a-card-links pull-left">Forgot password?</a>
                                                                                    <a href="register.php" id="id-a-new-user" class="cl-a-card-links pull-right">Create account</a>
                                                                                </div>
                                                                            </div>
                                                                        </form>
                                                                    </div>
                                                                </div>'); } else {
                                                                    if($_SESSION["user"]->authtype_id === 1){
                                                                        echo ('
                                                                        <div class="card small-screen-hidden">
                                                                            <a href="dashboard.php">
                                                                                <img class="card-img-top" data-src="images/dashboard.78d28716.jpg" alt="University at Buffalo: Greiner Hall">
                                                                                <div class="card-block">
                                                                                    <h5 class="card-title">Dashboard</h5>
                                                                                </div>
                                                                            </a>
                                                                        </div>');
                                                                    } else {
                                                                        echo ('
                                                                        <div class="card small-screen-hidden">
                                                                            <a href="#">
                                                                                <img class="card-img-top" data-src="images/casestudies.6d1bf636.png" alt="University at Buffalo, Greiner Hall Exterior">
                                                                                <div class="card-block">
                                                                                    <h5 class="card-title">
                                                                                        Case studies
                                                                                        <br>
                                                                                        <b>Under Construction</b>
                                                                                    </h5>

                                                                                </div>
                                                                            </a>
                                                                        </div>');
                                                                    }
                                                                 }
                                                                ?> </div></div></div></div></div></div></div></td></tr></table></div></section> <?php
                    include_once("videoModal.php");
                ?> <div><div><div class="index-footer row col-md-12 col-lg-12"><div class="col-md-4 col-lg-4"><h2 class="footer-title">Connect with Us!</h2><div class="social-media"><a href="https://www.facebook.com/ideacenterUB/" target="_blank"><img class="connect-facebook" alt="connect with facebook" src="images/Facebook.448e4684.png"></a><a href="https://twitter.com/IDeA_Center" target="_blank"><img class="connect-twitter" alt="connect with twitter" src="images/Twitter.d17c1959.png"></a></div></div><div class="col-md-4 col-lg-4"><h2 class="footer-title">Questions?</h2><div class="footer-content"><p style="font-weight: 600">Explore the <a href="instructions.php">FAQ</a> page or contact us directly.</p></div><div class="row col-md-12 col-lg-12" style="text-align: center"><div class="col-md-6 col-lg-6" id="telephone"><span style="font-weight: 600">Telephone:</span><br><span>+1(716) 829-5902</span></div><div class="col-md-6 col-lg-6" id="email"><span style="font-weight: 600">E-mail:</span><br><span>ap-idea@buffalo.edu</span></div></div></div><div class="col-md-4 col-lg-4"><h2 class="footer-title">Sign Up for News!</h2><div class="footer-content"><form class="news-form"><input type="email" aria-label="Email Address" class="form-control" id="news-signup-email" placeholder="E-mail Address"><div id="news-btn"><input class="btn btn-primary" id="news-signup-submit" type="button" value="Submit"></div><div style="padding-top: 10px"><span id="id-signup-short-inp-msg"></span></div></form></div></div></div></div></div><div> <?php
                    include_once("Footer.php");
                    ?> </div></div></section></div> <?php
        include_once("IdleTimeLogoutPopup.php");
    ?> <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.1.1/js/tether.min.js"></script><script src="JS/bootstrap.min.61f338f8.js"></script><script src="JS/bootstrap-select.min.69c3d792.js"></script><script src="JS/lib-unveil.min.157b97cb.js"></script><script src="JS/banner.min.b74cefaf.js"></script><script src="JS/intlTelInput.min.js"></script><script src="JS/register.min.22021cc5.js"></script><script src="JS/index.min.4e09dd2c.js"></script><script src="JS/popup.min.a855b93e.js"></script> <?php
        echo '<!-- isLoggedIn() : '.isLoggedIn() .'-->';
        echo '<!-- ts_survey_Complete  : '.$_SESSION["user"]->ts_survey_completed .'-->';
        echo '<!-- ts_survey_Complete !== NULL : '.($_SESSION["user"]->ts_survey_completed !== NULL) .'-->';
        echo '<!-- ($_SESSION["user"]->login_success_count%3 == 0) : '.($_SESSION["user"]->login_success_count%3 == 0) .'-->';
        if(isLoggedIn() && ($_SESSION["user"]->login_success_count%3 === 0) && ($_SESSION["user"]->ts_survey_completed !== NULL)){
            echo '<!-- showed survey -->';
            echo '<script>showSurvey()</script>';
        }
    ?> </body></html>