<?php
    include_once("CUserSession.php");
    include_once("CUtil.php");
    if(!isLoggedIn()){
        header("Location: register.php");
        die();
    }
?> <!DOCTYPE html><html lang="en"><head><title>MemberShip - isUD™</title><meta charset="utf-8"><meta name="viewport" content="width=device-width,initial-scale=1"><meta http-equiv="x-ua-compatible" content="ie=edge"><meta name="description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta name="keywords" content="inclusive design, universal design, accessibility, ada, barrier free design, wayfinding, anthropometry, design for all, diversity, wheelchair"><meta name="copyright" content="innovative solutions for Universal Design is a product of the University at Buffalo, Center for Inclusive Design and Environmental Access. All rights reserved."><meta name="dcterms.rightsHolder" content="The University at Buffalo, Center for Inclusive Design and Environmental Access."><meta property="og:title" content="Profile Membership - isUD™"><meta property="og:description" content="isUD™ offers resources and services to support and recognize adopters of universal design. isUD™ provides an interactive platform for browsing innovate solutions for UD, reference designs for designers and design resources that summarize the state of knowledge on a variety of topics related to UD."><meta property="og:image" content="/images/isUD_PR_PublicTransit_Facebook.e6c1a408.png"><meta property="og:site_name" content="thisisUD"><meta property="og:image:width" content="470"><meta property="og:image:height" content="246"><link rel="Shortcut Icon" href="favicon.ico"><link rel="stylesheet" href="CSS/bootstrap.min.7cc40c19.css"><link rel="stylesheet" href="CSS/bootstrap-select.min.92f660cd.css"><link rel="stylesheet" href="CSS/dataTables.bootstrap4.12f1d4f3.css"><link rel="stylesheet" href="CSS/custom.79b6d971.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css"><style>table {
        font-family: arial, sans-serif;
        border-collapse: collapse;
        width: 100%;
        }

        td, th {
        border: 0px solid #dddddd;
        text-align: center;
        padding: 15px;
        font-size: 14px;
        }

        tr:nth-child(1) {
        background-color: #f9f9f9;
        }

        tr:nth-child(even) {
        background-color: #f9f9f9;
        }

        select {
        -webkit-appearance: none;
        -moz-appearance: none;
        -ms-appearance: none;
        appearance: none;
        outline: 4;
        box-shadow: none;
        border: 0 !important;
        background: #ffffff;
        background-image: none;
        border: 6px solid transparent;
        border-color: #000;
        }

        select::-ms-expand {
        display: none;
        }

        .select {
        position: relative;
        display: flex;
        width: 12em;
        height: 2em;
        line-height: 2;
        background: #000000;
        overflow: hidden;
        border-radius: .45em;
        text-align-last:center;
        border: 1px solid transparent;
        margin:auto;
        }

        select {
        flex: 1;
        padding: 0 .5em;
        color: #000000;
        cursor: pointer;
        }

        .select::after {
        position: absolute;
        content: "";
        top: 11px;
        right: 10px;
        width: 0;
        height: 0;
        border: 6px solid transparent;
        border-color: #000 transparent transparent transparent;
        cursor: pointer;
        pointer-events: none;
        -webkit-transition: .25s all ease;
        -o-transition: .25s all ease;
        transition: .25s all ease;
        }</style></head><body><div class="cl-container cl-wrapper" id="id-wrapper"> <?php
            if(!isLoggedIn()){
                Util::ScopedIncludeOnce("Banner.php", array('includerFile' => __FILE__));
            }else{
                Util::ScopedIncludeOnce("Banner_Login.php", array('includerFile' => __FILE__));
            }
        ?> <section id="id-global-container"><div class="cl-div-width-container ongoing-projects"><section><div id="content-holder"><div id="dashboard"><div class="big-screen-hidden cl-div-solutions-holder"><p>Thank you for your interest in innovative solutions for Universal Design (isUD™). Due to the large amount of content, the solutions are not available on small screens or small browser windows. To see the complete list of solutions, please make your browser window full screen, or access the site on device with a larger screen. If you have any questions, please contact us at <a href="mailto:info@thisisud.com" target="_blank">info@thisisud.com</a>.</p></div><div class="small-screen-hidden cl-div-project-dashboard-holder"><div id="id-title-bar"><div class="cl-div-site-breadcrumb-static" style="font-size: 14px;"><span class="" style="font-size: 14px; font-weight: bold;"><a>My Account<a> <a style="color: grey;">> Membership</a></a></a></span></div></div><div class="cl-info-footer" id="id-title-bar" style="display:flex; margin-top:15px; width:100%"><div class="" id="id-project-title-text" style="align-self: auto;"><span class="cl-span-site-title">Membership</span></div></div><div><p id="opening-note" style="margin-left:15px; font-size:14px; margin-top:20px">Thank you for creating an isUD account. You currently have access to a 30-Day Free Trial membership. During the next 30 days, you will be able to create 1 project and access all solutions, drawings,and figures. With the free trial, you cannot submit the project for pre-certification review or isUD Certification with an on-site audit. The project will lock after 30 days. To regain access to the project, you must upgrade to a Supporter or Innovator membership within 1 year. If you have any questions, please contact us at <a href="mailto:ap-idea@buffalo.edu">ap-idea@buffalo.edu</a>.</p></div><div style="margin-top:50px"><table style="margin-right:20px"><tr style="border-bottom: 1px solid black;"><th class="pull-left">Benefits</th><th style="background-color:#F7941E">Free Trial</th><th>Supporter</th><th>Innovator</th></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Access all solutions</td><td style="border-right:1px dashed black; border-bottom:0px"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Access all drawings and figures</td><td style="border-right:1px dashed black; border-bottom:0px"><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Access all design resources</td><td style="border-right:1px dashed black; border-bottom:0px"></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Access a printable scorecard for all projects</td><td style="border-right:1px dashed black; border-bottom:0px"></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Submit projects for pre-certification, and isUD Certification with on-site audit</td><td style="border-right:1px dashed black; border-bottom:0px"></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Number of projects</td><td style="font-weight:bold; text-align:center; border-right:1px dashed black; border-bottom:0px">1 free/30 days</td><td style="font-weight:bold; text-align:center;">1 project/year</td><td style="font-weight:bold; text-align:center;">2 projects/year</td></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">User Accounts</td><td style="border-right:1px dashed black; border-bottom:0px">1</td><td>1</td><td>3</td></tr><tr><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Get a 20% discount on recertification if subscription is active for all 5 years</td><td style="border-right:1px dashed black; border-bottom:0px"></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr style="border-bottom: 1px solid black;"><td style="text-align:left; border-right:1px dashed black; border-bottom:0px">Access to free and discounted online course</td><td style="border-right:1px dashed black; border-bottom:0px"></td><td></td><td><i style="color:#F7941E; padding-right:18px;" class="fa fa-check"></i></td></tr><tr style="background-color: #ffffff;"><td style="text-align:left; border-right:1px dashed black; border-bottom:0px"><div><p style="font-weight:bold; float:left;">Cost &nbsp;</p><p style="float:left">(Membership purchases are non-refundable)</p></div></td><td style="border-right:1px dashed black; border-bottom:0px"></td><td style="font-weight:bold">$500/year</td><td style="font-weight:bold">$1000/year</td></tr><tr style="background-color: #ffffff; line-height:0%;"><td style="border-right:1px dashed black; border-bottom:0px"></td><td style="font-weight:bold; padding-bottom:0px; border-right:1px dashed black; border-bottom:0px">Free for 30 days</td><td style="font-weight:bold;">Number of Years</td><td style="font-weight:bold;">Number of Years</td></tr><tr style="background-color: #ffffff; line-height:0%"><td style="border-right:1px dashed black; border-bottom:0px"></td><td id="expiry-date" style="color:red; padding-bottom:55px; border-right:1px dashed black; border-bottom:1px dashed black"></td><td><div class="select"><select name="slct" id="slct-for-supporter"><option class="font-weight-bold" value="1">1 Year</option><option class="font-weight-bold" value="2">2 Years</option><option class="font-weight-bold" value="3">3 Years</option><option class="font-weight-bold" value="4">4 Years</option><option class="font-weight-bold" value="5">5 Years</option></select></div></td><td><div class="select"><select name="slct" id="slct-for-innovator"><option class="font-weight-bold" value="1">1 Year</option><option class="font-weight-bold" value="2">2 Years</option><option class="font-weight-bold" value="3">3 Years</option><option class="font-weight-bold" value="4">4 Years</option><option class="font-weight-bold" value="5">5 Years</option></select></div></td></tr><tr style="background-color: #ffffff; line-height:0%;"><td></td><td></td><td style="font-weight:bold;">Total</td><td style="font-weight:bold;">Total</td></tr><tr style="background-color: #ffffff; line-height:0%;"><td></td><td></td><td id="cost-in-dollars-supporter" style="font-weight:bold;">$500</td><td id="cost-in-dollars-innovator" style="font-weight:bold;">$1000</td></tr><tr style="background-color: #ffffff;"><td></td><td></td><td><input class="membershipbutton cl-supporter-mem" type="button" value="Select"></td><td><input class="membershipbutton cl-innovator-mem" type="button" value="Select"></td></tr></table></div></div></div></div></section></div></section> <?php
            include_once("Footer.php");
        ?>  <?php
            include_once("IdleTimeLogoutPopup.php");
        ?> </div><script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.1.1/js/tether.min.js"></script><script type="text/javascript">var userRole='<?php echo $_SESSION["user"]->authtype_id?>';</script><script src="JS/constants.min.45228e21.js"></script><script src="JS/bootstrap.min.61f338f8.js"></script><script src="JS/lib-unveil.min.c14400f8.js"></script><script src="JS/banner.min.481c978f.js"></script><script src="JS/index.min.4e09dd2c.js"></script><script src="JS/progressbar.min.c5d0fe77.js"></script><script src="JS/profileMemberShip.min.afcc493c.js"></script><script src="JS/popup.min.cbc0cd32.js"></script></body></html>